package Orchestrator;

import org.jnativehook.GlobalScreen;
import org.jnativehook.NativeHookException;
import org.jnativehook.keyboard.NativeKeyEvent;
import org.jnativehook.keyboard.NativeKeyListener;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Random;

/**
 * In this Class, all keybinds actions are defined
 * @author root
 */

public class KeyboardListener implements NativeKeyListener {
    public void nativeKeyPressed(NativeKeyEvent e) {

    	if (Main.keybind_write_instr != null && NativeKeyEvent.getKeyText(e.getKeyCode()).equals(Main.keybind_write_instr))
        {
        	Main.log("Key Pressed: " + Main.keybind_write_instr);  
        	Main.refillhwnd();
        	String command = null;
			switch (Main.lang)
            {
            case "fr":
            	command="/plugins charger orchestrator";
            break;
            case "en":
            	command="/plugins load orchestrator";
            break;
            case "de":
            	command="/zusatzmodule laden orchestrator";
            break;
            } 
        	
			Main.log("Now loading orchestrator LUA plugin in game ...");
			Dispatch(command,false, -1);
			Main.log("... and saving instruments to files");
			Dispatch("/party_instr write",false, -1);			
		
        }
    	
    	if (Main.keybind_music != null && NativeKeyEvent.getKeyText(e.getKeyCode()).equals(Main.keybind_music))
        {
        	Main.log("Key Pressed: " + Main.keybind_music);        	
        	Main.refillhwnd();    	
        	String command = null;
			switch (Main.lang)
            {
            case "fr":
            	command="/musique";
            break;
            case "en":
            	command="/music";
            break;
            case "de":
            	command="/musik";
            break;
            } 
			       	
			Dispatch(command,false, -1);
			
        }
    	
    	if (Main.keybind_raid_invit != null && NativeKeyEvent.getKeyText(e.getKeyCode()).equals(Main.keybind_raid_invit))
        {
        	Main.log("Key Pressed: " + Main.keybind_raid_invit); 
        	Main.refillhwnd();
           	String command2 = null;
    			switch (Main.lang)
                {
                case "fr":
                	command2="/raid inviter ";
                break;
                case "en":
                	command2="/raid invite ";
                break;
                case "de":
                	command2="/schlachtzug einladen ";
                break;
                }
    			
    			Dispatch(command2,true, -1);
    			
    	        try {
					Thread.sleep(Integer.valueOf(Main.sendkeys_timer));
				} catch (NumberFormatException | InterruptedException e1) {
					Main.log("NumberFormatException | InterruptedException e1 KeyboardListener:line 90");
				}
        }
    	
    	if (Main.keybind_follow != null && NativeKeyEvent.getKeyText(e.getKeyCode()).equals(Main.keybind_follow))
        {
        	Main.log("Key Pressed: " + Main.keybind_follow);   
        	Main.refillhwnd();
        	String command = null;
			switch (Main.lang)
            {
            case "fr":
            	command="/suivre";
            break;
            case "en":
            	command="/follow";
            break;
            case "de":
            	command="/folge";
            break;
            }			       	
			
			@SuppressWarnings("unchecked")
			HashSet<Account> HashsetAccounts2 =  (HashSet<Account>) Main.HashsetAccounts.clone();

			Iterator<Account> local_ITaccounts = HashsetAccounts2.iterator();

			// vk_f2 = 0x71 = 113
			int i=113;
			while( local_ITaccounts.hasNext() )
				{
					Account a = local_ITaccounts.next();
					String str = "VK_F2="+i;
					Main.log("Sending ["+str+"] to "+a.getCharacter() +" with hwnd "+ a.getHWND());
					
					if(a.getHWND() != Main.main_character_hwnd)
					{
						Main.jni.minimize(a.getHWND(), 9);
					}
					Main.jni.minimize(a.getHWND(), 5);
					Main.jni.sendkey(i,a.getHWND());
					try {
						Thread.sleep(Integer.valueOf(Main.sendkeys_timer));
					} catch (NumberFormatException | InterruptedException e2) {
						e2.printStackTrace();
					}
					Main.jni.sync(command, a.getHWND());
					try {
						Thread.sleep(Integer.valueOf(Main.sendkeys_timer));
					} catch (NumberFormatException | InterruptedException e1) {
						Main.log(e1.toString());
					}
					if(a.getHWND() != Main.main_character_hwnd)
					{
						Main.jni.minimize(a.getHWND(), 6);
					}
				}			
        }
    	
        if (Main.keybind_sync != null && NativeKeyEvent.getKeyText(e.getKeyCode()).equals(Main.keybind_sync))
        {
        	Main.log("Key Pressed: " + Main.keybind_sync);        	
        	//check if any known hwnds are known at least
        	//in case orchestrator would've been started separately from clients
        	Main.refillhwnd();      	
        	Main.show_ini_data();
        	Main.sync();
        }
        
        if (Main.keybind_launcher != null && NativeKeyEvent.getKeyText(e.getKeyCode()).equals(Main.keybind_launcher))
        {
        	Main.log("Key Pressed: " + Main.keybind_launcher);
        	Main.refillhwnd();         	
        	Main.launch();			    	
        }
        
        if(Main.keybind_kill_orchestrator != null && NativeKeyEvent.getKeyText(e.getKeyCode()).equals(Main.keybind_kill_orchestrator))
        {
        	Main.log("Key Pressed: " + Main.keybind_kill_orchestrator);
        	Main.log("-------------LOG END HERE---------------");
        	Main.log(randomLOTRquote());
        	Main.log("----------------------------------------");
    		try {
				GlobalScreen.unregisterNativeHook();
			} catch (NativeHookException e1) {
				Main.log("NativeHookException KeyboardListener:line 186");
			}

        	System.exit(0);
        }
   }
     
    
    /**
     * Goal of this method is to send a simple command to clients
     * if boolean is true, commands will be sent only to main character with others characters name appended to command, useful for raids commands
     * @param command
     * @param b 
     */
    @SuppressWarnings("unchecked")
    /**
      	   Main.jni.minimize(local_role.getHWND(), 9);
           Main.jni.sync(command, local_role.getHWND());
           Thread.sleep(Integer.valueOf(Main.sendkeys_timer));
           Main.jni.minimize(local_role.getHWND(), 6);
     */
	private void Dispatch(String command, boolean ismainchar, int max) {
    	HashSet<Account> HashsetAccounts2 =  (HashSet<Account>) Main.HashsetAccounts.clone();

		Iterator<Account> local_ITaccounts = HashsetAccounts2.iterator();
		Main.log("Dispatching command["+command+"] with parameter "+ ismainchar);
		int counter = 0;
		if (max == -1) 
				{
				max=HashsetAccounts2.size();
				}
		boolean guard = true;
		//loop while we have'nt processed all accounts 
			while(counter < max || local_ITaccounts.hasNext() )
			{
				counter ++;
				Account a = local_ITaccounts.next();
				if(ismainchar) //if this boolean is true, we will send commands to main character only (for raid invit)
				{					
					Main.log("["+ Main.main_character + "] will execute command ["+command+a.getCharacter()+"]");
					
					//if current window is not main character window
					if(a.getHWND() != Main.main_character_hwnd)
					{
						//then put it foreground
						Main.jni.minimize(a.getHWND(), 9);
					}
					if(!a.getCharacter().equals(Main.main_character)) //dont self invite main character in raid, useless ...
					{
					//send the /invite raid name here	
					Main.jni.sync(command+a.getCharacter(), Main.main_character_hwnd);					
						try {				
							//make sure here the window is foreground
							Main.jni.setforeground(a.getHWND());
							Thread.sleep(Integer.valueOf(Main.raid_invit_timer)); //let 3s for user to invite the new character in raid, as his windows is foregrounded, it is easy
							
						} catch (NumberFormatException | InterruptedException e1) {
							Main.log("NumberFormatException | InterruptedException e1 KeyBoard Listener:line 238");
						}					
					}			       
					
					if(guard)
					{//execute this code only 1 time to create the raid after inviting the 1st character
	               	String command2 = null;
	        			switch (Main.lang)
	                    {
	                    case "fr":
	                    	command2="/raid crer ";
	                    break;
	                    case "en":
	                    	command2="/raid create ";
	                    break;
	                    case "de":
	                    	command2="/schlachtzug erstellen ";
	                    break;
	                    }
	        		Main.log("["+ Main.main_character + "] will execute command ["+command2+"]");
	        		//send the /raid create here, to transform communityt in raid whatever happens
	    			Main.jni.sync(command2, Main.main_character_hwnd);
	    			guard = false;
					}
					
				//now make all push F1 to follow ? not yet
					
					
				}
				else
				{	//in this case we just send the command to the current character
					Main.log("["+a.getCharacter() + "] will execute command ["+command+"]");
					if(a.getHWND() != Main.main_character_hwnd)
					{
						Main.jni.minimize(a.getHWND(), 9);
					}
					Main.jni.sync(command, a.getHWND());
					try {
						Thread.sleep(Integer.valueOf(Main.sendkeys_timer));
					} catch (NumberFormatException | InterruptedException e) {
						Main.log("NumberFormatException | InterruptedException e KeyBoardListener:line:310");
					}
					if(a.getHWND() != Main.main_character_hwnd)
					{
					Main.jni.minimize(a.getHWND(), 6);
					}
				}				
			}		
	}

    /**
     * do i even really need to comment this ?
     * Well okay then, i just had some fun to append some random LOTR quotes from books at the end of logs ...
     * @return
     */
	public static String randomLOTRquote() {   	
    	switch (new Random().nextInt(10))
    	{
    	case 1:
    	return "It's a dangerous business, Frodo, going out your door. You step onto the road, and if you don't keep your feet, there's no knowing where you might be swept off to.";
    	
    	case 2:
    	return "You cannot pass, I am a servant of the Secret Fire, wielder of the flame of Anor. You cannot pass. The dark fire will not avail you, flame of Udn. Go back to the Shadow! You cannot pass.";
    	
    	case 3:
    	return "Fly you fools ";
    	
    	case 4:
    	return "Farewell! I go to find the Sun!";
    	
    	case 5:
    	return "But I am the real Strider, fortunately. I am Aragorn son of Arathorn; and if by life or death I can save you, I will.";
    	
    	case 6:
    	return "Go not to the Elves for counsel, for they will say both no and yes.";
    	
    	case 7:
    	return "Go back to the abyss! Fall into nothingness that awaits you and your master!";
    	
    	case 8:
    	return "Elves and Dragons! Cabbages and potatoes are better for me and you. Don't go getting mixed up in the business of your betters, or you'll land in trouble too big for you.";
    	
    	case 9:
    	return "Despair is only for those who see the end beyond all doubt.";
    	
    	case 10:
    	return "I wish none of this had happened.";    	
    	}
		return null;
   	}

	public void nativeKeyReleased(NativeKeyEvent e) {
	} 

    public void nativeKeyTyped(NativeKeyEvent e) {
	}   
}